/*
  Gerador da sequencia que o Murilo enviou
para a OBM-L em 05/07/04 s 20:44.

  Criado por Bruno Frana dos Reis, em 06/07/04, sob GPL.
  
  Nao garanto absolutamente nada quanto ao funcionamento
do cdigo. Apenas digo que em minha mquina est tudo OK.

  Do jeito em que est, d para listar at o 19o.
  Para ver mais nmeros da sequencia, aumente o valor
de MAXSZ.

uso: ./seq num
ex: ./seq 10 -> pega os 10 primeiros numeros da sequencia
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MAXSZ 256

int next(char *s) {
  char *new,buf[4];
  int i,sz_s,count;

  if((new=(char *)malloc(MAXSZ*sizeof(char)))==NULL) {
    return 0;
  }
  
  *new=0;
  
  sz_s=strlen(s);

  for(i=0;i<sz_s;i++) {
    count=1;
    while(s[i]==s[i+1]){
      i++;
      count++;
    }
    sprintf(buf,"%d%c\0",count,s[i]);
    #ifdef DEBUGME
    printf("->%s\n",buf);
    #endif
    strcat(new,buf);
    #ifdef DEBUGME
    printf("--->%s\n",new);
    #endif
  }

  strcpy(s,new);
  #ifdef DEBUGME
  printf("!\n");
  #endif
  free(new);
  return 1;
}

int main(int argc, char **argv) {
  char *s;
  int i,j;
  if(argc<2) { printf("uso: seq num\n"); exit(1);}
  
  s=(char *)malloc(MAXSZ*sizeof(char));
  strcpy(s,"1");
  
  i=atoi(argv[1]);

  printf("Criado por Bruno Frana dos Reis\n");

  for(j=1;j<i;j++) {
    printf("%d: %s\n",j,s);
    if(!next(s)) { printf("ERRO!\n");exit(1); }
  }
  printf("%d: %s\n",j,s);
  free(s);
  
  return 0;
    
}
